/***********************************************************
Tworld
***********************************************************/
var hostString="";

function init(){
  this.initStage=ST_PRE;
  this.loginData=["https://nicasams.sktelecom.com:2552/icas/fc/LogOnSV","ID","PASSWORD","URL="+encodeURIComponent("http://www.tworld.co.kr/loginservlet.do?returnURL=http%3A%2F%2Fwww.tworld.co.kr%2Fnormal.do%3FserviceId%3DS_MYTW0057%26viewId%3DV_MYTW0190")];
  this.dataURL="http://message.tworld.co.kr/SktSendMsg.do";
  this.pattern=/"message":"SUCCESS"/;
}
function process(aHttpChannel, aData) {
  switch(this.stage){
  case ST_PRE:
    this.loginTime=null;
    this.getHtml("http://www.tworld.co.kr/twd/main/fla_index.jsp");
    return false;
  case ST_PRE_RES:
    var fnd=aData.match(/"SERVERIP"\s+value="(\S+?)"/);
    if(fnd){
      this.stage=ST_LOGIN;
      this.getHtml(this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]+"&SERVERIP="+encodeURIComponent(fnd[1]));
      return false;
    }
    break;
  case ST_LOGIN_RES:
    var fnd=aData.match(/url=(\S+)\'/);
    if(fnd){
      this.getHtml(fnd[1]);
      return false;
    }
    break;
  case ST_LOGIN_RES+1:
    this.getHtml("http://www.tworld.co.kr/normal.do?serviceId=S_ETC_0031&viewId=V_CENT0221");
    return false;
  case ST_LOGIN_RES+2:
    var fnd=aData.match(/<iframe[\s\S]+?src="(\S+?)"/);
    if(fnd){
      this.getHtml(fnd[1]);
      return false;
    }else if(aData.match(/<iframe\s*name="SMSAuth"/)){
      fnd=aData.match(/"svc_num_1"[\s\S]+?value=(\d+)\s+selected[\s\S]+?"svc_num_2"[\s\S]+?value="(\d+)"[\s\S]+?"svc_num_3"[\s\S]+?value="(\d+)"/);
      if(fnd){
        var num=fnd[1]+"-"+fnd[2]+"-"+fnd[3];
        fnd2=aData.match(/<form.+?name="form2"\s*action="(\S+?)"([\S\s]+?)<\/form>/i);
        if(fnd2){
          var re=/<input.+?name=(\S+)\s+value=["']?(\S*?)["']?>/g;
          var o;
          var post="";
          while ((o = re.exec(fnd2[2])) != null){
            if(post)post+="&";
            post+=o[1]+"="+encodeURIComponent(o[2]);
          }
          post+="&svc_num="+encodeURIComponent(num);
          var rs=this.main.openAuthDialog(this,0,num,ST_LOGIN_RES+7,"http://www.tworld.co.kr"+fnd2[1],post);
          if(rs){
            fnd2=aData.match(/\s{3}<form.+?name="form1".+?action="(\S+?)"([\S\s]+?)<\/form>/i);
            var re=/<input.+?name=["']?(\S+?)["']?\s+value=["']?(\S*?)["']?>/g;
            var o;
            var post="";
            while ((o = re.exec(fnd2[2])) != null){
              if(post)post+="&";
              post+=o[1]+"="+encodeURIComponent(o[2]);
            }
            post+="&authType=S&svcNum1="+fnd[1]+"&svcNum2="+fnd[2]+"&svcNum3="+fnd[3]+"&confirmNum="+encodeURIComponent(rs);
            this.stage=ST_LOGIN_RES+2;
            this.getHtml("http://www.tworld.co.kr"+fnd2[1],post);
            return true;
          }
        }
      }
    }
    break;
  case ST_LOGIN_RES+3:
    var fnd=aData.match(/tParam\'\s+value=\'(\S+)\'>/);
    if(fnd){
      this.stage=ST_DATA;
      this.getHtml(this.dataURL,"tParam="+fnd[1]+"&chkYn=Y");
      return false;
    }
    break;
  case ST_LOGIN_RES+7:
    this.stage=ST_LOGIN_RES+2;
    return true;
  case ST_SEND_RES+1:
    var fnd=aData.match(/"authYn":"Y"/);
    if(fnd){
      var rs=this.main.openAuthDialog(this,0,this.userMDN,ST_SEND_RES+4,"http://message.tworld.co.kr/websms/SktAhtnNoRq.do","userMdn="+this.userMDN);
      if(rs){
        this.post=this.post.replace("authNum=&","authNum="+encodeURIComponent(rs)+"&").replace("authYn=N","authYn=Y");
        this.stage=ST_SEND_RES;
        this.getHtml("http://message.tworld.co.kr/SktSendMsgContents.do",this.post);
        return true;
      }else{
        ////////this.main.retry=RETRY_LIMIT;
        ////////Send fail;
        this.main.msg=[];
        aData="";
      }
    }
    this.stage=ST_SEND_RES;
    break;
  case ST_SEND_RES+4://auth received
    this.stage=ST_SEND_RES+1;
    return true;
  }
  return this.baseProcess(aHttpChannel, aData);
}
function onSend(sender,receiver,msg){
  var msg_org=this.main.msg[0][M_MSG];
  //this.isMMS=true;
  if(this.isMMS)msg=encodeURIComponent("<DIV><FONT color=rgb(0,0,0)>"+msg_org+"</FONT></DIV>");
  this.post="mmsYn=N&mode=SEND&freeCount="+this.count
          +"&grp=0&sendMdn="+this.userMDN
          +"&recvMdn="+receiver+"%7C"
          +"&callMdn="+sender
          +"&title="+encodeURIComponent(this.byteCutString(msg_org,24))
          +"&msg="+encodeURIComponent(msg_org)
          +"&authNum=&recvName=%7C&type=&svc_type=&bgcolor=&upPath=&bgiCid=&galleryCid=&bgiPrice=&galleryPrice=&text=&authYn=N&deliveryTime=&imgUrl=&imgCid=&contsCnt=";
  this.stage=ST_SEND_RES+1;
  this.getHtml("http://message.tworld.co.kr/SktSendMsgContents.do",this.post);
  return true;
}
function getCount(aData){
	if(!this.userMDN){
    var fnd=aData.match(/id="sendMdn".+?value="(\S+?)"/);
    if(fnd){
      this.userMDN=fnd[1];
      this.setSender(this.userMDN);
    }
  }
  var fnd=aData.match(/id="gFreeCnt">(\d+)</);
  return fnd?fnd[1]:-1;
}

function byteCutString(str, len){
	 var l = 0;
	 for (var i=0; i<str.length; i++) {
	         l += (str.charCodeAt(i) > 128) ? 2 : 1;
	         if (l > len) return str.substring(0,i) + "...";
	 }
	 return str;
}
